<?php

/**
 * Menu callback
 */
function ltp_preview($module)
{
    // скачивание .po файла --------------------------------------------------------------------------------------------
    module_load_include('inc', 'update', 'update.compare');
    module_load_include('update.inc', 'live_translation');
    include_once './includes/locale.inc';
    
    $modules = update_get_projects();
    $output = '<p>Предпросмотр нового перевода модуля <strong>' . $module . '-' . $modules[$module]['info']['version'] . '</strong></p>';
    $langcode = 'ru';
    $import_time = variable_get('live_translation_import_time', array());
    $import_time = isset($import_time[$langcode][$module]) ? $import_time[$langcode][$module] : 0;
    
    $file_url = implode('/', array(
        _live_translation_servers($langcode),
        LIVE_TRANSLATION_SERVER_URL,
        $module,
        $modules[$module]['info']['version'],
        $langcode,
        $import_time
    ));

    $filename = 'preview-' . $module . '-' . $import_time . '.po';
    $filepath = file_directory_temp() . '/' . $filename;
    
    @set_time_limit(0);
    
    $contents = drupal_http_request($file_url);
    
    if (!$contents)
    {
        drupal_set_message('Невозможно скачать файл ' . $file_url);
        return '';
    }
    else if ($contents->error != '')
    {
        drupal_set_message('Ошибка при скачивании файла: ' . $contents->error);
        return '';
    }
    
    file_put_contents($filepath, $contents->data);
    // end -------------------------------------------------------------------------------------------------------------
    
    
    // парсинг скачанного .po файла ------------------------------------------------------------------------------------
    $file = array('filepath' => $filepath, 'filename' => $filename);
    _locale_import_read_po('mem-store', (object)$file);
    $strings = _locale_import_one_string('mem-report');
    array_shift($strings);
    // end -------------------------------------------------------------------------------------------------------------
    
    
    // генерация таблицы "Обновлённые переводы" ------------------------------------------------------------------------
    $enStrings = array_keys($strings);
    $tableHeader = array('Строка', 'Существующий перевод', 'Новый перевод');
    $tableData = array();
    
    $result = db_query("
        SELECT source, translation FROM {locales_source} ls
        LEFT JOIN {locales_target} lt ON ls.lid = lt.lid
        WHERE ls.source IN(" . db_placeholders($enStrings, 'varchar') . ")
    ", $enStrings);
    
    while ($row = db_fetch_object($result))
    {
        $tableData[] = array($row->source, $row->translation, $strings[$row->source]);
        unset($strings[$row->source]);
    }
    
    if (count($tableData) > 0)
    {
        $table = theme('table', $tableHeader, $tableData);
        $output .= theme('fieldset', array('#title' => 'Обновлённые строки', '#value' => $table));
    }
    // end -------------------------------------------------------------------------------------------------------------
    
    
    // генерация таблицы "Новые переводы" ------------------------------------------------------------------------------
    if (count($strings) > 0)
    {
        $tableHeader = array('Строка', 'Перевод');
        $tableData = array();
        
        foreach($strings as $en => $ru)
        {
            $tableData[] = array($en, $ru);
        }
        
        $table = theme('table', $tableHeader, $tableData);
        $output .= theme('fieldset', array('#title' => 'Новые строки', '#value' => $table));
    }
    // end -------------------------------------------------------------------------------------------------------------
    
    
    unlink($filepath);
    
    return $output;
}
